#global commit0 aef6790272fce5d64d36d191dcb79d97021bfda7
#global date 20220104
#global shortcommit0 #(c=%{commit0}; echo ${c:0:7})
%global tag %{version}

%global debug_package %{nil}
%global dkms_name zenpower3
%define modprobed_dir /etc/modprobe.d

Name:       dkms-%{dkms_name}
Version:    0.2.0
Release:    4%{?dist}
# old release string: #{!?tag:.#{date}git#{shortcommit0}}
Summary:    AMD Zen temperature driver kernel module
License:    GPLv2
URL:        https://git.exozy.me/a/zenpower3
BuildArch:  noarch

%if 0%{?tag:1}
Source0:    %{url}/archive/v%{version}.tar.gz#/%{dkms_name}-%{version}.tar.gz
%else
Source0:    %{url}/archive/%{commit0}.tar.gz#/%{dkms_name}-%{shortcommit0}.tar.gz
%endif
# auto add blacklist config for k10temp module
Source1:    %{name}.conf

# Add Lucienne support
Patch0:    %{url}/commit/c176fdb0d5bcba6ba2aba99ea36812e40f47751f.patch

BuildRequires:  sed
Provides:   %{dkms_name}-kmod = %{?epoch:%{epoch}:}%{version}
Requires:   dkms

%description
Zenpower3 is a Linux kernel driver for reading temperature, voltage(SVI2), current(SVI2) and power(SVI2) for AMD Zen family CPUs, now with Zen 3 support!

%prep
%if 0%{?tag:1}
%autosetup -p1 -n %{dkms_name}-%{version}
%else
%autosetup -p1 -n %{dkms_name}-%{commit0}
%endif

sed -i -e "s/@CFLGS@//" -e "s/@VERSION@/%{version}/" dkms.conf

%build

%install
# Create empty tree:
mkdir -p %{buildroot}%{_usrsrc}/%{dkms_name}-%{version}/
mkdir -p %{buildroot}%{modprobed_dir}/
install -m 0644 dkms.conf %{buildroot}%{_usrsrc}/%{dkms_name}-%{version}/
install -m 0644 Makefile %{buildroot}%{_usrsrc}/%{dkms_name}-%{version}/
install -m 0644 zenpower.c %{buildroot}%{_usrsrc}/%{dkms_name}-%{version}/
install -m 0644 %{SOURCE1} %{buildroot}%{modprobed_dir}/

%post
dkms --rpm_safe_upgrade add -m %{dkms_name} -v %{version} || :
# Rebuild and make available for the currently running kernel:
dkms --rpm_safe_upgrade build -m %{dkms_name} -v %{version} || :
dkms --rpm_safe_upgrade install -m %{dkms_name} -v %{version} --force || :

%preun
# Remove all versions from DKMS registry:
dkms --rpm_safe_upgrade remove -m %{dkms_name} -v %{version} --all || :

%files
%{_usrsrc}/%{dkms_name}-%{version}
%{modprobed_dir}/%{name}.conf

%changelog
* Sat Nov 05 2022 H3o66 <chris.h3o66@gmail.com> - 0.2.0-4
- Add patch for AMD Lucienne support

* Sat Feb 26 2022 Christian Birk <mail@birkc.de> - 0.2.0-3
- fix description.

* Sat Feb 26 2022 Christian Birk <mail@birkc.de> - 0.2.0-2
- add blacklist config to modprobe dir.

* Sat Feb 26 2022 Christian Birk <mail@birkc.de> - 0.2.0-1
- First build.
